//File: 	playGui.cs
//Author:	Base FPS example file.
//Date:		19 Oct 2005
//Notes:
//
//	19 Oct 2005	MP
//	- Modified to support text based player health and ammo.
//

function PlayGui::onWake(%this)
{
   // Turn off any shell sounds...
   // alxStop( ... );

$enableDirectInput = "1";
activateDirectInput();

   // Message hud dialog
Canvas.pushDialog( MainChatHud );
chatHud.attach(HudMessageVector);

   // just update the action map here
moveMap.push();
   
   // hack city - these controls are floating around and need to be clamped
schedule(0, 0, "refreshCenterTextCtrl");
schedule(0, 0, "refreshBottomTextCtrl");
}

function PlayGui::onSleep(%this)
{
Canvas.popDialog( MainChatHud  );
   
   // pop the keymaps
moveMap.pop();
}


//-----------------------------------------------------------------------------

function refreshBottomTextCtrl()
{
BottomPrintText.position = "0 0";
}

function refreshCenterTextCtrl()
{
CenterPrintText.position = "0 0";
}

//Function used to set the health value of the text based health indicator.
function clientCmdSetHealthAmountHud(%value)
{
HealthAmount.setText(%value);

if (%value >= 75)
{
HealthIcon.setBitmap("diespheredie.tom/client/scripts/greenhealthbar");
}

if (%value < 75 && %value >= 50)
{
HealthIcon.setBitmap("diespheredie.tom/client/scripts/yellowhealthbar");
}

else if (%value < 50 && %value >=25)
{
HealthIcon.setBitmap("diespheredie.tom/client/scripts/orangehealthbar");
}

else if (%value < 25 && %value >= 0)
{
HealthIcon.setBitmap("diespheredie.tom/client/scripts/redhealthbar");
}
}

//Function used to set the ammo count in the ballistic ammo counter.
function clientCmdSetAmmoAmountHud(%value)
{
AmmoAmount.setText("Ammo: " @ %value);
}

//Function used to set the resistances and armor values.
function clientCmdSetResistances(%Ballistic, %Energy, %Armor)
{
	GuiBallisticResistanceTxt.setText(%Ballistic);
    GuiEnergyResistanceTxt.setText(%Energy);
    GuiArmorTxt.setText(%Armor);
}

//Updates player poison indicator.
function clientCmdSetPoisonIndicator(%aPoisonLength)
{
	if (%aPoisonLength > 0)
	{
		GuiPoisonOnTxt.visible = 1;
		GuiPoisonLeftTxt.visible = 1;
		GuiPoisonLeftTxt.setText(%aPoisonLength);
	}
	else
	{
		GuiPoisonOnTxt.visible = 0;
		GuiPoisonLeftTxt.visible = 0;
	}
}

//Updates player corrosion indicator.
function clientCmdSetCorrosionIndicator(%aCorrosionLength)
{
	if (%aCorrosionLength > 0)
	{
		GuiCorrodedOnTxt.visible = 1;
		GuiCorrodedLeftTxt.visible = 1;
		GuiCorrodedLeftTxt.setText(%aCorrosionLength);
	}
	else
	{
		GuiCorrodedOnTxt.visible = 0;
		GuiCorrodedLeftTxt.visible = 0;
	}
}

//Updates player numbness indicator.
function clientCmdSetNumbnessIndicator(%aNumbnessLength)
{
	if (%aNumbnessLength > 0)
	{
		GuiNumbedOnTxt.visible = 1;
		GuiNumbedLeftTxt.visible = 1;
		GuiNumbedLeftTxt.setText(%aNumbnessLength);
	}
	else
	{
		GuiNumbedOnTxt.visible = 0;
		GuiNumbedLeftTxt.visible = 0;
	}
}

//Updates player score value.
function clientCmdUpdatePlayerScore(%aNewScoreValue)
{
	GuiScoreTxt.setText("Score: " @ %aNewScoreValue);
}

//Function used to set weapon levels. 
function clientCmdSetWeaponLevels(%MachineGun, %ShotGun, %RocketLauncher, %PulseLaser, %BeamCannon)
{
	//echo("Updating Weapons...");
	//GuiWeaponLevelsTxt.setText("MG:" @ %MachineGun @ " SG:" @ %ShotGun @ " RL:" @ %RocketLauncher @ " PL:" @ %PulseLaser @ " BC:" @ %BeamCannon);

	//Handle MachineGun
	if (%MachineGun == 2)
	{
		MachineGunLevel.setBitmap("diespheredie.tom/client/ui/weaponleveltwo");
	}
	else if (%MachineGun == 3)
	{
		MachineGunLevel.setBitmap("diespheredie.tom/client/ui/weaponlevelthree");
	}
	else
	{
		MachineGunLevel.setBitmap("diespheredie.tom/client/ui/weaponlevelone");
	}

	//Handle ShotGun
	if (%ShotGun == 2)
	{
		ShotGunLevel.setBitmap("diespheredie.tom/client/ui/weaponleveltwo");
	}
	else if (%ShotGun == 3)
	{
		ShotGunLevel.setBitmap("diespheredie.tom/client/ui/weaponlevelthree");
	}
	else
	{
		ShotGunLevel.setBitmap("diespheredie.tom/client/ui/weaponlevelone");
	}

	//Handle RocketLauncher
	if (%RocketLauncher == 2)
	{
		RocketLauncherLevel.setBitmap("diespheredie.tom/client/ui/weaponleveltwo");
	}
	else if (%RocketLauncher == 3)
	{
		RocketLauncherLevel.setBitmap("diespheredie.tom/client/ui/weaponlevelthree");
	}
	else
	{
		RocketLauncherLevel.setBitmap("diespheredie.tom/client/ui/weaponlevelone");
	}

	//Handle PulseLaser
	if (%PulseLaser == 2)
	{
		PulseLaserLevel.setBitmap("diespheredie.tom/client/ui/weaponleveltwo");
	}
	else if (%PulseLaser == 3)
	{
		PulseLaserLevel.setBitmap("diespheredie.tom/client/ui/weaponlevelthree");
	}
	else
	{
		PulseLaserLevel.setBitmap("diespheredie.tom/client/ui/weaponlevelone");
	}

	//Handle BeamCannon
	if (%BeamCannon == 2)
	{
		BeamCannonLevel.setBitmap("diespheredie.tom/client/ui/weaponleveltwo");
	}
	else if (%BeamCannon == 3)
	{
		BeamCannonLevel.setBitmap("diespheredie.tom/client/ui/weaponlevelthree");
	}
	else
	{
		BeamCannonLevel.setBitmap("diespheredie.tom/client/ui/weaponlevelone");
	}

	
}


