//File: HiveFuncs.cs
//Author:	Justin Selgrad
//Date:		19 Nov 2005
//Notes:
//		- Spawner functions to generate random enemies and add them to the flocks

// Execute our spawner objects here
exec("./hive.cs");
$SpawnList[0] = 0; // To hold onto all our spawners. Sub 0 will equal the count.

// Add Spawner ----------------------------------------------
function AddSpawner(%this, %obj)
{
echo("Adding Spawner "@%this@", "@%obj);
 $SpawnList[0]++;                      // Inc spawn count
 $SpawnList[$SpawnList[0]] = %obj;     // Point to spawner
 //%obj.setHidden(true);                 // Hide the spawner for now
}//AddSpawner

// View Spawners --------------------------------------------
function ViewSpawners(%bool)
{      // Hide/show all the spawner objects

 if(%bool) 
Echo("Making all spawners visible");
 else 
	Echo("Hiding all spawners");
  
 for(%i = 1; %i <= $SpawnList[0]; %i++)
{
  $SpawnList[%i].setHidden(!%bool);
 }//for
}//ViewSpawners

// Spawn ----------------------------------------------------
function Spawn(%spawner)
{
 // Figure out how many we want to spawn
 %count = GetRandom(%spawner.getDataBlock().spawnMin, %spawner.getDataBlock().spawnMax);
  
 if(%count == 0) return;

 for(%i = 1; %i <= %count; %i++){
  // Pick a datablock to use for the bot
  %block = GetRandom(1, %spawner.getDataBlock().botDataBlock[0]);
  %dblock = %spawner.getDataBlock().botDataBlock[%block];

	//%name = %count;
	%obj = %spawner;
if(%dblock $= "DemoPlayerMelee")
{
	//%name = MeleeAnt@%count;
	%bot = MeleeAntAIPlayer::spawn(%name,%obj);
}
else if(%dblock $= "DemoPlayerEnergy")
{
//%name = EnergyAnt@%count;
	%bot = EnergyAntAIPlayer::spawn(%name,%obj);
}
else if(%dblock $= "DemoPlayerBallistic")
{
//%name = BallisticAnt@%count;
	%bot = ballisticAntAIPlayer::spawn(%name,%obj);
}
else if(%dblock $= "DemoPlayerPoison")
{
//%name = PoisonAnt@%count;
	%bot = PoisonAntAIPlayer::spawn(%name,%obj);
}
else if(%dblock $= "DemoPlayerCorrosion")
{
//%name = CorrosionAnt@%count;
	%bot = CorrosionAntAIPlayer::spawn(%name,%obj);
}
else if(%dblock $= "DemoPlayerNumb")
{
//%name = NumbAnt@%count;
	%bot = NumbAntAIPlayer::spawn(%name,%obj);
}
else if(%dblock $= "DemoPlayerBee")
{
	//%name = Bee@%count;
	%bot = BeeAIPlayer::spawn(%name,%obj);
}

//new AIPlayer(){
   //datablock = %dblock;
   //parent = %spawner;
  //botname = %count;
  //};//new AIPlayer  

 %bot.registerAIPlayer();
  // Add it to be deleted
  MissionCleanup.Add(%bot);
  
  // Set transform
  %bot.setTransform(NudgeSpawn(%spawner.getTransform()));   // Nudgespawn will keep them from standing
                        // on top of each other (for the most part)
   }//for
}//Spawn

function SpawnNumber(%spawner,%count)
{
 // Figure out how many we want to spawn
 //%count = GetRandom(%spawner.getDataBlock().spawnMin, %spawner.getDataBlock().spawnMax);
  
 if(%count == 0) return;

 for(%i = 1; %i <= %count; %i++){
  // Pick a datablock to use for the bot
  %block = GetRandom(1, %spawner.getDataBlock().botDataBlock[0]);
  %dblock = %spawner.getDataBlock().botDataBlock[%block];

%obj = %spawner;
if(%dblock $= "DemoPlayerMelee")
{
	//%name = MeleeAnt@%count;
	%bot = MeleeAntAIPlayer::spawn(%name,%obj);
}
else if(%dblock $= "DemoPlayerEnergy")
{
//%name = EnergyAnt@%count;
	%bot = EnergyAntAIPlayer::spawn(%name,%obj);
}
else if(%dblock $= "DemoPlayerBallistic")
{
//%name = BallisticAnt@%count;
	%bot = ballisticAntAIPlayer::spawn(%name,%obj);
}
else if(%dblock $= "DemoPlayerPoison")
{
//%name = PoisonAnt@%count;
	%bot = PoisonAntAIPlayer::spawn(%name,%obj);
}
else if(%dblock $= "DemoPlayerCorrosion")
{
//%name = CorrosionAnt@%count;
	%bot = CorrosionAntAIPlayer::spawn(%name,%obj);
}
else if(%dblock $= "DemoPlayerNumb")
{
//%name = NumbAnt@%count;
	%bot = NumbAntAIPlayer::spawn(%name,%obj);
}
else if(%dblock $= "DemoPlayerBee")
{
	//%name = Bee@%count;
	%bot = BeeAIPlayer::spawn(%name,%obj);
}
//new AIPlayer(){
   //datablock = %dblock;
   //parent = %spawner;
  //botname = %count;
  //};//new AIPlayer   
echo(%bot.position);
%bot.setTransform(NudgeSpawn(%spawner.getTransform()));
echo(%bot.position);
 %bot.registerAIPlayer();
  // Add it to be deleted
  MissionCleanup.Add(%bot);
  
  // Set transform
  //%bot.setTransform(NudgeSpawn(%spawner.getTransform()));   // Nudgespawn will keep them from standing
                        // on top of each other (for the most part)
   }//for
}//Spawn


// Spawn Number to Flock
function SpawnNumberToFlock(%spawner,%count,%flock)
{
 // Figure out how many we want to spawn
 //%count = GetRandom(%spawner.getDataBlock().spawnMin, %spawner.getDataBlock().spawnMax);
  
 if(%count == 0) return;

 for(%i = 1; %i <= %count; %i++){
  // Pick a datablock to use for the bot
  %block = GetRandom(1, %spawner.getDataBlock().botDataBlock[0]);
echo("Sp#toF- block: "@%block);
  %dblock = %spawner.getDataBlock().botDataBlock[%block];
echo("Sp#toF- dblock: "@%dblock);

%obj = %spawner;

//if(%dblock $= "DemoPlayerMelee")
//{
//	new Item(MeleeMarker) {
//         position = NudgeSpawn(%obj.position);
//         rotation = "1 0 0 0";
//         scale = "1 1 1";
//         dataBlock = "MeleeAntAIPlayerMarker";
//         collideable = "0";
//         static = "1";
//         rotate = "1";
//      };
//
//	
//}
//else if(%dblock $= "DemoPlayerEnergy")
//{
//new Item(EnergyMarker) {
//         position = NudgeSpawn(%obj.position);
//         rotation = "1 0 0 0";
//         scale = "1 1 1";
//         dataBlock = "EnergyAntAIPlayerMarker";
//         collideable = "0";
//         static = "1";
//         rotate = "1";
//      };
//}
//else if(%dblock $= "DemoPlayerBallistic")
//{
//new Item(BallisticMarker) {
//         position = NudgeSpawn(%obj.position);
//         rotation = "1 0 0 0";
//         scale = "1 1 1";
//         dataBlock = "BallisticAntAIPlayerMarker";
//         collideable = "0";
//         static = "1";
//         rotate = "1";
//      };
//}   


if(%dblock $= "DemoPlayerMelee")
{
	//%name = MeleeAnt@%count;
	%bot = MeleeAntAIPlayer::spawn(%name,%obj);
}
else if(%dblock $= "DemoPlayerEnergy")
{
//%name = EnergyAnt@%count;
	%bot = EnergyAntAIPlayer::spawn(%name,%obj);
}
else if(%dblock $= "DemoPlayerBallistic")
{
//%name = BallisticAnt@%count;
	%bot = ballisticAntAIPlayer::spawn(%name,%obj);
}
else if(%dblock $= "DemoPlayerPoison")
{
//%name = PoisonAnt@%count;
	%bot = PoisonAntAIPlayer::spawn(%name,%obj);
}
else if(%dblock $= "DemoPlayerCorrosion")
{
//%name = CorrosionAnt@%count;
	%bot = CorrosionAntAIPlayer::spawn(%name,%obj);
}
else if(%dblock $= "DemoPlayerNumb")
{
//%name = NumbAnt@%count;
	%bot = NumbAntAIPlayer::spawn(%name,%obj);
}
else if(%dblock $= "DemoPlayerBee")
{
	//%name = Bee@%count;
	%bot = BeeAIPlayer::spawn(%name,%obj);
}
//new AIPlayer(){
   //datablock = %dblock;
   //parent = %spawner;
  //botname = %count;
  //};//new AIPlayer   
%bot.setTransform(NudgeSpawn(%spawner.getTransform()));
 %bot.registerAIPlayerToFlock(%flock);
  // Add it to be deleted
  MissionCleanup.Add(%bot);
  
  // Set transform
//%bot.setPosition(%spawner.getPosition());
  //%bot.setTransform(NudgeSpawn(%spawner.getTransform()));   // Nudgespawn will keep them from standing
                        // on top of each other (for the most part)
echo(%bot.getPosition());
   }//for
}//Spawn


// Spawn Type To Flock ------------------------------------
function SpawnSingleTypeToFlock(%spawner,%dblock,%flock)
{
	echo("******************    "@%flock);
	// Figure out how many we want to spawn
	//%count = GetRandom(%spawner.getDataBlock().spawnMin, %spawner.getDataBlock().spawnMax);
	%count = 1;

	%obj = %spawner;

	if(%dblock $= "DemoPlayerMelee")
	{
		//%name = MeleeAnt@%count;
		%bot = MeleeAntAIPlayer::spawn(%name,%obj);
	}
	else if(%dblock $= "DemoPlayerEnergy")
	{
	//%name = EnergyAnt@%count;
		%bot = EnergyAntAIPlayer::spawn(%name,%obj);
	}
	else if(%dblock $= "DemoPlayerBallistic")
	{
	//%name = BallisticAnt@%count;
		%bot = ballisticAntAIPlayer::spawn(%name,%obj);
	}
	else if(%dblock $= "DemoPlayerPoison")
	{
	//%name = PoisonAnt@%count;
		%bot = PoisonAntAIPlayer::spawn(%name,%obj);
	}
	else if(%dblock $= "DemoPlayerCorrosion")
	{
	//%name = CorrosionAnt@%count;
		%bot = CorrosionAntAIPlayer::spawn(%name,%obj);
	}
	else if(%dblock $= "DemoPlayerNumb")
	{
	//%name = NumbAnt@%count;
		%bot = NumbAntAIPlayer::spawn(%name,%obj);
	}
	else if(%dblock $= "DemoPlayerBee")
	{
	echo("In DemoPlayerBee");
	//%name = Bee@%count;
		%bot = BeeAIPlayer::spawn(%name,%obj);
	}

	%bot.registerAIPlayerToFlock(%flock);
//%bot.registerAIPlayer();
	// Add it to be deleted
%bot.setTransform(NudgeSpawn(%spawner.getTransform()));
	MissionCleanup.Add(%bot);
	  
							// on top of each other (for the most part)
	echo(%bot.getPosition());
	
}//Spawn





// Spawn all -----------------------------------------------
function SpawnAll()
{
 Echo("*** Performing global spawn ***");
 for(%i = 1; %i <= $SpawnList[0]; %i++){
  Spawn($SpawnList[%i]);
 }//for
 Echo("*** Global spawn of " @ %i @ " bots complete ***");
}//SpawnAll

// Nudge Spawn -----------------------------------------------------------------
function NudgeSpawn(%origTransform)
{
echo(%origTransform);
 // X & Y are to move the position
 %wordx = Nudge(GetWord(%origTransform, 0));
 %wordy = Nudge(GetWord(%origTransform, 1));
 %wordz = NudgeZ(GetWord(%origTransform, 2));

 %origTransform = SetWord(%origTransform, 0, %wordx);
 %origTransform = SetWord(%origTransform, 1, %wordy);
  %origTransform = SetWord(%origTransform, 2, %wordz);
 return %origTransform;
}//NudgeSpawn

function Nudge(%val)
{
 %high = 20;   // Min/Max value we can move the spawn in any direction
 %low = 0;
%sign = GetRandom(0,1);
if(%sign == 0)
	%val =  %val + (GetRandom(%low, %high) * -1);
else
	%val = %val + GetRandom(%low, %high);

 return %val;
}//Nudge
function NudgeZ(%val)
{
// %high = 40;   // Min/Max value we can move the spawn in any direction
// %low = 20;
 %val = %val + 50;//GetRandom(%low, %high);

 return %val;
}//Nudge
