//File: 	battery.cs
//Author:	TL
//Date:		28 Nov 2005
//Notes:
//
// 28 Nov 2005
//-----------------------------------------------------------------------------
// Battery updates energy ammo and shield
//-----------------------------------------------------------------------------

datablock ItemData(Battery)
{
   // Mission editor category, this datablock will show up in the
   // specified category under the "shapes" root category.
category = "Battery";

   // Basic Item properties
shapeFile = "~/data/shapes/items/healthPatch.dts";
mass = 1;
friction = 1;
elasticity = 0.3;


repairPercentage = 0.1;
maxInventory = 0; // No pickup or throw
};

function Battery::onCollision(%this,%obj,%col)
{	
	//replenish ammo
	echo("Battery Current ammo: " @ %col.getInventory(EnergyAmmo));
	echo(EnergyAmmo.maxInventory);   
	%repair = %col.getInventory(EnergyAmmo) + EnergyAmmo.maxInventory * %this.repairPercentage;
	if (%repair > EnergyAmmo.maxInventory)
		%repair = EnergyAmmo.maxInventory;
	%col.setInventory(EnergyAmmo, %repair);
	echo("New Ammo: " @ %col.getInventory(EnergyAmmo));
		
	//replenish shield
	%maxShield = %col.getShieldMaxLevel();
	echo("MAX SHIELD: " @ %maxShield);
	echo("CURRENT SHIELD: " @ %col.getShieldCurrentLevel());
	%repairshield = %col.getShieldCurrentLevel() + %col.getShieldMaxLevel() * %this.repairPercentage;
	echo("REPAIRSHIELD: " @ %repairshield);
	
	if (%repairshield > %col.getShieldMaxLevel())
		%repairshield = %col.getShieldMaxLevel();
	
	%col.setShieldMaxLevel(%repairshield);
	echo("New Shield: " @ %col.getShieldCurrentLevel());
   
	if (%col.client)
		messageClient(%col.client, 'MsgBatteryUsed', '\c2Battery Applied');
}


datablock ItemData(MidBattery : Battery)
{
	className = "Battery";
	repairPercentage = 0.5;
};


datablock ItemData(LargeBattery : Battery)
{
	className = "Battery";
	repairPercentage = 1.0;
};


