//File: 	hive.cs
//Author:	Justin Selgrad
//Date:		2 Nov 2005
//Notes:	Destructable hive
//
//	-	2 Nove 2005
//			First attempts
//	-	2 Nov 2005
//		First Attempts successful
//		Added Explosion Particle Effects, direct from weapons, modified to be bigger
//		Explosion modified to be huge with camera shake affects
//	-	18 Nov 2005 JS
//		removed spawner stuff and put into seperate object
exec("./Enemies/AIPlayer.cs");
exec("./Enemies/BallisticAntaiPlayer.cs");
exec("./Enemies/EnergyAntaiPlayer.cs");
exec("./Enemies/MeleeAntaiPlayer.cs");
exec("./Enemies/PoisonAntaiPlayer.cs");
exec("./Enemies/CorrosionAntaiPlayer.cs");
exec("./Enemies/NumbAntaiPlayer.cs");

exec("~/data/shapes/hive/hive.cs");
datablock StaticShapeData(TestShape)
{
category = "Hives";
shapeFile = "~/data/shapes/hive/hive.dts";
maxDamage = 100;
destroyedLevel = 100;

spawnMin = 1; // Min to spawn
spawnMax = 10; // Max to spawn

botDataBlock[0] = 7;
botDataBlock[1] = DemoPlayerMelee;
botDataBlock[2] = DemoPlayerEnergy;
botDataBlock[3] = DemoPlayerBallistic;
botDataBlock[4] = DemoPlayerPoison;
botDataBlock[5] = DemoPlayerCorrosion;
botDataBlock[6] = DemoPlayerNumb;
botDataBlock[7] = DemoPlayerBee;

mass = 10;
friction = 1;
elasticity = 0.3;

explosion = MachinegunExplosion;
//debrisShapeName = ="./testcube_debri.dts";
//debris = StaticShapeDataDebri;
};

function TestShape::onAdd(%this,%obj)
{
echo("adding spawner to list");
AddSpawner(%this, %obj);
echo("spawner "@%obj@" pos: "@%obj.getTransform());
//	%temp = new StaticShape() 
//	{
//		position = %obj.position;
//		rotation = "1 0 0 0";
//		scale = "1 1 1";
//		dataBlock = "GenericSpawner";
//	};
}


//---------------------------------
//General StaticShapeData functions
//---------------------------------

function StaticShapeData::damage(%this, %obj, %sourceObject, %position, %damage, %damageType)
{
	echo("Blowing stuff up");
	%obj.applyDamage(%damage);
}

function StaticShapeData::onDamage(%this, %obj, %delta)
{
	%damage = %obj.getDamageLevel();
	if (%damage >= %this.destroyedLevel)
	{
		if(%obj.getDamageState() !$= "Destroyed")
		{
			%obj.setDamageState(Destroyed);
		}
	}
	else
	{
		if(%obj.getDamageState() !$= "Enabled")
			%obj.setDamageState(Enabled);
	}

}


function StaticShapeData::onDestroyed(%this, %obj, %prevState)
{
	echo("Hive Destroyed!");
	%explosion = new Explosion() 
	{
		dataBlock = "MachinegunExplosion";
		sourceObject = %obj.sourceObject;
		sourceSlot = %obj.sourceSlot;
		client = %obj.client;
		position = %vec;
	};


	MissionCleanup.add(%explosion);

	%obj.playThread(0,"death");
	%obj.schedule(300, "delete");
}

//****************
//explosions ?++
datablock ParticleData(MachinegunExplosionSmoke)
{
textureName          = "~/data/shapes/particles/smoke";
dragCoeffiecient     = 100.0;
gravityCoefficient   = 0;
inheritedVelFactor   = 0.25;
constantAcceleration = -0.30;
lifetimeMS           = 1200;
lifetimeVarianceMS   = 300;
useInvAlpha =  true;
spinRandomMin = -80.0;
spinRandomMax =  80.0;

colors[0]     = "0.56 0.36 0.26 1.0";
colors[1]     = "0.2 0.2 0.2 1.0";
colors[2]     = "0.0 0.0 0.0 0.0";

sizes[0]      = 4.0;
sizes[1]      = 2.5;
sizes[2]      = 1.0;

times[0]      = 0.0;
times[1]      = 0.5;
times[2]      = 1.0;
};

datablock ParticleEmitterData(MachinegunExplosionSmokeEmitter)
{
ejectionPeriodMS = 10;
periodVarianceMS = 0;
ejectionVelocity = 4;
velocityVariance = 0.5;
thetaMin         = 0.0;
thetaMax         = 180.0;
lifetimeMS       = 250;
particles = "MachinegunExplosionSmoke";
};

datablock ParticleData(MachinegunExplosionFire)
{
textureName          = "~/data/shapes/particles/fire";
dragCoeffiecient     = 100.0;
gravityCoefficient   = 0;
inheritedVelFactor   = 0.25;
constantAcceleration = 0.1;
lifetimeMS           = 1200;
lifetimeVarianceMS   = 300;
useInvAlpha =  false;
spinRandomMin = -80.0;
spinRandomMax =  80.0;

colors[0]     = "0.8 0.4 0 0.8";
colors[1]     = "0.2 0.0 0 0.8";
colors[2]     = "0.0 0.0 0.0 0.0";

//sizes[0]      = 1.5;
//sizes[1]      = 0.9;
//sizes[2]      = 0.5;
sizes[0]      = 50;
sizes[1]      = 25;
sizes[2]      = 12.5;

times[0]      = 0.0;
times[1]      = 0.5;
times[2]      = 1.0;
};

datablock ParticleEmitterData(MachinegunExplosionFireEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 0.8;
   velocityVariance = 0.5;
   thetaMin         = 0.0;
   thetaMax         = 180.0;
   lifetimeMS       = 1000;//250
   particles = "MachinegunExplosionFire";
};

datablock ParticleData(MachinegunExplosionSparks)
{
   textureName          = "~/data/shapes/particles/spark";
   dragCoefficient      = 1;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 350;

   colors[0]     = "0.60 0.40 0.30 1.0";
   colors[1]     = "0.60 0.40 0.30 1.0";
   colors[2]     = "1.0 0.40 0.30 0.0";

   sizes[0]      = 0.25;
   sizes[1]      = 0.15;
   sizes[2]      = 0.15;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(MachinegunExplosionSparkEmitter)
{
ejectionPeriodMS = 3;
periodVarianceMS = 0;
ejectionVelocity = 5;
velocityVariance = 1;
ejectionOffset   = 0.0;
thetaMin         = 0;
thetaMax         = 180;
phiReferenceVel  = 0;
phiVariance      = 360;
overrideAdvances = false;
orientParticles  = true;
lifetimeMS       = 100;
particles = "MachinegunExplosionSparks";
};

datablock ExplosionData(MachinegunSubExplosion1)
{
   offset = 0;
   emitter[0] = MachinegunExplosionSmokeEmitter;
   emitter[1] = MachinegunExplosionSparkEmitter;
};

datablock ExplosionData(MachinegunSubExplosion2)
{
   offset = 1.0;
   emitter[0] = MachinegunExplosionSmokeEmitter;
   emitter[1] = MachinegunExplosionSparkEmitter;
};

datablock ExplosionData(MachinegunExplosion)
{
soundProfile = MachinegunExplosionSound;
lifeTimeMS = 1200;

   // Volume particles
particleEmitter = MachinegunExplosionFireEmitter;
particleDensity = 175;//75
particleRadius = 20;//2

   // Point emission
emitter[0] = MachinegunExplosionSmokeEmitter;
emitter[1] = MachinegunExplosionSparkEmitter;

   // Sub explosion objects
subExplosion[0] = MachinegunSubExplosion1;
subExplosion[1] = MachinegunSubExplosion2;
   
   // Camera Shaking
shakeCamera = true;
camShakeFreq = "90.0 90.0 90.0"; //10,11,10
camShakeAmp = "5.0 5.0 5.0";//"1.0 1.0 1.0"
camShakeDuration = 3.0;//1
camShakeRadius = 1000.0;//50

   // Exploding debris
debris = MachinegunExplosionDebris;
debrisThetaMin = 0;
debrisThetaMax = 60;
debrisPhiMin = 0;
debrisPhiMax = 360;
debrisNum = 30;
debrisNumVariance = 2;
debrisVelocity = 5;//1
debrisVelocityVariance = 0.5;
   
   // Impulse
impulseRadius = 10;
impulseForce = 15;

   // Dynamic light
lightStartRadius = 6;
lightEndRadius = 3;
lightStartColor = "0.5 0.5 0";
lightEndColor = "0 0 0";
};