//File: 	immunity.cs
//Author:	TL
//Date:		14 Nov 2005
//Notes:
//
//Power ups for immunity.

datablock ItemData(BallisticImmunity)
{
	// Mission editor category
category = "Immunity";

mass = 1;
friction = 1;
elasticity = 0.3;

	// Basic Item properties - Using the octahedron shape.
shapeFile = "~/data/shapes/markers/octahedron.dts";
maxInventory = 0; // No pickup or throw
};

function BallisticImmunity::onCollision(%this,%obj,%col)
{
echo("In Ballistic Immunity");
if(%col.getClassName() $= "Player")
{
	if(%col.ballsched !=0)
		cancel(%col.ballsched); 
	if(%col.ballsched ==0)   // don't want to set if the player already has the immunity
		%col.prevBallresist = %col.getBallisticResistance(); 
			  
	%col.setBallisticResistance(100.0);	
			//%col.client.setResistances(100.0, %col.getEnergyResistance(), %col.getArmorValue());
	if (%col.client)
	messageClient(%col.client, 'MsgBallisticImmunity', 'Resistance to Ballistic Enabled');
	%col.ballsched = %this.schedule(15000,"restoreBallisticImmunity",%col,%col.prevBallresist);
	//%this.schedule(10000,"respawnBallisticImmunity",%obj.getName(),%obj.position,%obj.rotation,%obj.scale,%obj.dataBlock);
	%obj.delete(); 
}
	
}

function BallisticImmunity::restoreBallisticImmunity(%this,%col,%prevBallresist)
{
	if (%col.client)
		messageClient(%col.client, 'MsgBallisticImmunityUsed', 'Resistance to Ballistic Disabled');
	%col.setBallisticResistance(%prevBallresist);
	//%col.client.setResistances(%prevBallresist, %col.getEnergyResistance(), %col.getArmorValue());
}

function BallisticImmunity::respawnBallisticImmunity(%this,%nName,%nPosition,%nRotation,%nScale,%nDataBlock)
{
	new Item(%nName) 
	{
		position = %nPosition;
		rotation = %nRotation;
		scale = %nScale;
		dataBlock = %nDataBlock;
	};		
}



datablock ItemData(EnergyImmunity)
{
	// Mission editor category
	category = "Immunity";

	mass = 1;
	friction = 1;
	elasticity = 0.3;

	// Basic Item properties - Using the octahedron shape.
	shapeFile = "~/data/shapes/markers/octahedron.dts";
	maxInventory = 0; // No pickup or throw
};

function EnergyImmunity::onCollision(%this,%obj,%col)
{
	echo("In Energy Immunity");
if(%col.getClassName() $= "Player")
	{
	if(%col.energysched !=0)
		cancel(%col.energysched); 
	if(%col.energysched ==0)   // don't want to set if the player already has the immunity
		%col.prevEnergyresist = %col.getEnergyResistance(); 
	  
  
	%col.setEnergyResistance(100.0);
  //%col.client.setResistances(%col.getBallisticResistance(), 100.0, %col.getArmorValue());
	if (%col.client)
		messageClient(%col.client, 'MsgEnergyImmunity', 'Resistance to Energy Enabled');
	%col.energysched = %this.schedule(15000,"restoreEnergyImmunity",%col,%col.prevEnergyresist);
	//%this.schedule(10000,"respawnEnergyImmunity",%obj.getName(),%obj.position,%obj.rotation,%obj.scale,%obj.dataBlock);
	%obj.delete(); 
	}	
}

function EnergyImmunity::restoreEnergyImmunity(%this,%col,%prevEnergyresist)
{
  //%col.client.setResistances(%col.getBallisticResistance(), %prevEnergyresist, %col.getArmorValue());
	if (%col.client)
		messageClient(%col.client, 'MsgEnergyImmunityUsed', 'Resistance to Energy Disabled');
	%col.setEnergyResistance(%prevEnergyresist);
}
		
function EnergyImmunity::respawnEnergyImmunity(%this,%nName,%nPosition,%nRotation,%nScale,%nDataBlock)
{
	new Item(%nName) 
	{
		position = %nPosition;
		rotation = %nRotation;
		scale = %nScale;
		dataBlock = %nDataBlock;
	};		
}

