//File: 	machinegunupgrade.cs
//Author:	TL
//Date:		02 Nov 2005
//Notes:
//Upgrades Machinegun Level, will need to be created in the world when time is right for the player



datablock ItemData(MachinegunUpgrade)
{
	category = "Upgrade";

	//basic item properties
	shapeFile = "~/data/shapes/items/healthKit.dts";
	mass = 1;
	friction = 1;
	elasticity = 0.3;
	pickUpName = "MachinegunUpgrade";
	maxInventory = 2;
};

function MachinegunUpgrade::create(%data)
{
   //Don't want machinegunupgrades to re-spawn, wants the game manager to determine when to release into the world
	%obj = new Item() 
	{
		dataBlock = %data;
		static = false;
		rotate = true;
		};
	return %obj;
}



function MachinegunUpgrade::onCollision(%this,%obj,%col)
{
//03 NOV TL
//Now the upgrades will only work on the player, AIPlayers can still pick up the upgrade before the player, but
//they will not upgrade their weapons.  Set max level at 3
	//echo("colliding with upgrade");
	%currLevel = %col.getCurrentMachineGunLevel();
	//%inv = %col.getInventory(%this);
	//echo("Number of upgrades " @ %inv);
	%col.decInventory(%this,1);
	//%inv = %col.getInventory(%this);
	//echo("New Number of upgrades " @ %inv);
	if(%col.getClassName() !$= "AIPlayer" && %currLevel < 3)
	{
  	  %col.setCurrentMachineGunLevel(1);
		//Update the players weapon levels.
		%col.client.setWeaponLevels(%col.GetCurrentMachineGunLevel(), %col.GetCurrentShotgunLevel(), %col.GetCurrentRocketLauncherLevel(), %col.GetCurrentPulseLaserLevel(), %col.GetCurrentLaserBeamLevel()); 

	}
	
//if Machinegun is currently equipped, need to mount the upgraded version
	%currWeapon = %col.getMountedImage($WeaponSlot).item.getName();

	if(%currWeapon $= "Machinegun")
	{
		%currLevel = %col.getCurrentMachineGunLevel();
		//echo("MACHINELEVEL " @ %currLevel);
		if (%currLevel == 2)
		  %col.mountImage(MachinegunImageLev2,0);
		else if (%currLevel == 3)
		  %col.mountImage(MachinegunImageLev3,0);
		else  //should not occur because should not be at Level 1
		  %col.mountImage(MachinegunImage,0);
	}
}