//File: 	rocketlauncherupgrade.cs
//Author:	TL
//Date:		07 Nov 2005
//Notes:
//Upgrades RocketLauncher Level, will need to be created in the world when time is right for the player



datablock ItemData(RocketLauncherUpgrade)
{
	category = "Upgrade";

	//basic item properties
	shapeFile = "~/data/shapes/items/healthKit.dts";
	mass = 1;
	friction = 1;
	elasticity = 0.3;
	pickUpName = "RocketLauncherUpgrade";
	maxInventory = 2;
};

function RocketLauncherUpgrade::create(%data)
{
   //Don't want machinegunupgrades to re-spawn, wants the game manager to determine when to release into the world
	%obj = new Item() 
	{
	dataBlock = %data;
	static = false;
	rotate = true;
	};
	return %obj;
}



function RocketLauncherUpgrade::onCollision(%this,%obj,%col)
{

	%currLevel = %col.getCurrentRocketLauncherLevel();
	%col.decInventory(%this,1);	
	if(%col.getClassName() !$= "AIPlayer" && %currLevel < 3)
	{
		%col.setCurrentRocketLauncherLevel(1);
		
		//Update the players weapon levels.
		%col.client.setWeaponLevels(%col.GetCurrentMachineGunLevel(), %col.GetCurrentShotgunLevel(), %col.GetCurrentRocketLauncherLevel(), %col.GetCurrentPulseLaserLevel(), %col.GetCurrentLaserBeamLevel()); 

	}
	

	%currWeapon = %col.getMountedImage($WeaponSlot).item.getName();

	if(%currWeapon $= "RocketLauncher")
	{
		%currLevel = %col.getCurrentRocketLauncherLevel();
		if (%currLevel == 2)
			%col.mountImage(RocketLauncherImageLev2,0);
		else if (%currLevel == 3)
			%col.mountImage(RocketLauncherImageLev3,0);
		else  //should not occur because should not be at Level 1
			%col.mountImage(RocketLauncherImage,0);
	}
}