//-----------------------------------------------------------------------------
// Torque Game Engine
//
// Copyright (c) 2002 ToRK
// Portions Copyright (c) 2001-2002 GarageGames.Com
// Portions Copyright (c) 2001-2002 by Sierra Online, Inc.
//-----------------------------------------------------------------------------

$numTeleports = 0;

datablock TriggerData(TargetTeleportTrigger)
{
   tickPeriodMS = 500;
};
datablock AudioProfile(TargetTeleportBuzz)
{
   fileName = "~/data/sound/fx/electricity.wav";
   description = AudioClose3d;
	preload = true;
};
datablock AudioProfile(TeleportInitSound)
{
   fileName = "~/data/sound/fx/zzap.wav";
   description = AudioClose3d;
	preload = true;
};

function TargetTeleportTrigger::onEnterTrigger(%data, %obj, %colObj)
{
   %client = %colObj.client;
   if(!%client)
   {
      echo("not a client!");
      return;
   }
   %checkname = %obj.getName();
   if($numTeleports == 0)
   {
      // search for Triggers by their name once, so every trigger
      // which has "TeleportTrigger" in its name is counted
      $numTeleports = getMultiTriggerCount("TeleportTrigger");
      echo("$numTeleports:" SPC $numTeleports);
      // set the text fields in the TeleportGui
      TeleportGui.initTextControls($numTeleports);
   }
   if(%checkname !$= $currMultiTeleTrigger)
   {
      // show and initialize TeleportGui
      $teleInitSound = serverPlay3D(TeleportInitSound,%client.player.getTransform());
      Canvas.pushDialog(TeleportGui);
      TeleportGui.initializeBeam(%client, %checkname);
   }
}

function TargetTeleportTrigger::startAction(%this, %callingClient, %checkname, %targetNum)
{
   %target = "TeleportTrigger" @ %targetNum;
   // we don't want to beam to the current teleport, do we?
   if(%target !$= %checkname)
   {
      CommandToClient(%callingClient,'bottomprint',"Teleporter initializing... good luck... buahahaha!!",2,10);
      $teleSched = schedule(2000,0,"goScotty",%callingClient,%target);
     	$teleSound = serverPlay3D(TargetTeleportBuzz,%callingClient.player.getTransform());
      %callingClient.player.setCloaked(true);
      // save the target - until the teleported client leaves it, then reset
      $currMultiTeleTrigger = %target;
   }
}

function TargetTeleportTrigger::onLeaveTrigger(%data, %obj, %colObj)
{
   %client = %colObj.client;
   if(!%client)
   {
      echo("not a client!");
      return;
   }
   %checkname = %obj.getName();
   cancel($teleSched);
   alxStop($teleSound);
   alxStop($teleInitSound);
   %client.player.setCloaked(false);
   // if the player leaves the target trigger,
   // he can use it again, too... so reset the global var
   if(%checkname $= $currMultiTeleTrigger)
   {
      $currMultiTeleTrigger = "";
   }
   // hide TeleportGui
   Canvas.popDialog(TeleportGui);
}

function TargetTeleportTrigger::onTickTrigger(%data, %obj)
{
}
// *********************************
// Helper functions
// *********************************

// do the teleport
function goScotty(%client, %target)
{
   // beam me up!
   commandToServer('TeleportPlayer', %client, %target);
}

// find the number of teleport triggers by name comparison
function getMultiTriggerCount(%name)
{
   %dataGroup = "Teleporters";
   %triggerCount = 0;
   for(%i = 0; %i < %dataGroup.getCount(); %i++)
   {
      %obj = %dataGroup.getObject(%i);
      if(%obj.getClassName() !$= "Trigger")
      {
         // no trigger!
         continue;
      }
      if((strStr(%obj.getDatablock().getName(), %name) != -1) && isObject(%obj))
      {
         echo(%i SPC "Found Trigger:" SPC %obj.getName());
         %triggerCount++;
      }
   }
   return %triggerCount;
}

